<script lang="ts">
import Vue from 'vue';
import SlpHorizontalRule from './horizontal-rule.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'FeaturedMedia',
  components: {
    SlpHorizontalRule,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <SlpContainer
    :class="{ 'slp-mb-96': !data.horizontal_rule && !data.no_margin_bottom }"
  >
    <div
      v-if="data.header"
      class="slp-flex slp-flex-column slp-align-items-center slp-mb-48"
      :data-aos="data.header_animation"
      :data-aos-duration="data.header_animation_duration"
    >
      <SlpTypography tag="h2" variant="heading2" class="slp-mb-8"
        >{{ data.header }}
      </SlpTypography>
      <SlpTypography tag="p" variant="body1">{{ data.text }}</SlpTypography>
    </div>
    <SlpRow :class="{ 'full-background': data.with_background }">
      <SlpColumn
        v-for="(media, index) in data.media"
        :key="`${media.title}-${index}`"
        :cols="data.column_size"
        class="slp-mb-16"
      >
        <client-only>
          <a
            class="link-wrapper"
            :href="media.link ? media.link.href : null"
            :data-ga-name="media.link ? media.link.data_ga_name : null"
            :data-ga-location="media.link ? media.link.data_ga_location : null"
          >
            <div
              class="slp-card feature"
              :class="{
                'feature--center': media.align_center,
                'feature--shadow-hover': media.shadow_hover,
                'feature--opacity': media.with_opacity,
              }"
              :data-aos="media.aos_animation"
              :data-aos-duration="media.aos_duration"
              :data-aos-offset="media.aos_offset"
            >
              <div class="feature__media">
                <img
                  v-if="media.image"
                  :src="media.image.url"
                  :alt="media.image.alt ? media.image.alt : ''"
                  loading="lazy"
                />
                <lite-vimeo
                  v-if="media.video"
                  :videoid="getVimeoVideoId(createVideoSource(media.video.url))"
                  autoplay
                ></lite-vimeo>
                <div
                  v-if="media.icon"
                  class="feature__media--icon feature__icon"
                >
                  <SlpIcon
                    :name="media.icon.name"
                    :alt="media.icon.variant"
                    :variant="media.icon.variant"
                    :hex-color="media.icon.hex_color"
                  />
                </div>
              </div>
              <div class="feature__content">
                <SlpTypography tag="h4" variant="heading4" class="slp-mb-8"
                  >{{ media.title }}
                </SlpTypography>
                <div
                  v-if="media.text"
                  class="feature__text"
                  :class="{ 'slp-mb-32': media.link }"
                  v-html="$md.render(media.text)"
                ></div>
                <a
                  v-if="media.link"
                  :href="media.link.href"
                  :data-ga-name="media.link.data_ga_name"
                  :data-ga-location="media.link.data_ga_location"
                >
                  <SlpTypography variant="body1">
                    {{ media.link.text ? media.link.text : $t('learnMore') }}
                  </SlpTypography>
                </a>
              </div>
            </div>
          </a>
        </client-only>
      </SlpColumn>
    </SlpRow>
    <SlpHorizontalRule v-if="data.horizontal_rule" />
  </SlpContainer>
</template>

<style scoped lang="scss">
.full-background {
  position: relative;

  &:before {
    content: '';
    position: absolute;
    top: 0;
    left: 50%;
    transform: translateX(-50%);
    height: calc(100% - (96px * 2));
    margin-top: 96px;
    width: 100vw;
    background: #f8f8f8;
  }
}

a.link-wrapper {
  color: inherit;
}

.feature {
  padding: 20px;
  display: flex;
  flex-direction: column;
  height: 100%;
  transition: all 0.5s ease-in-out;

  @media (min-width: $breakpoint-md) {
    margin: $spacing-8;
  }

  &--center {
    text-align: center;
  }

  &--shadow-hover {
    &:hover {
      box-shadow: 0 2px 50px rgba($color-surface-700, 0.25);
      transition: 0.3s ease-in-out all;
      a {
        text-decoration: underline;
      }
    }
  }

  &--opacity {
    opacity: 0.4 !important;
  }

  &__media {
    lite-vimeo {
      width: 100%;
      height: 170px;
    }

    img {
      width: 100%;
    }

    .feature__icon {
      width: 5rem !important;
      margin-bottom: $spacing-8;
    }

    &--icon {
      &:deep .slp-icon {
        height: 100%;
        width: 100%;
      }
    }
  }

  &__text {
    font-size: 16px;

    &:deep ul {
      list-style: unset;
      padding: revert;
    }
  }

  &__title-img {
    height: 36px;
    margin-right: $spacing-16;
  }

  &__content {
    margin-top: $spacing-8;
    margin-bottom: $spacing-8;

    a {
      display: block;
      margin-top: $spacing-8;
      position: absolute;
      bottom: $spacing-32;
      color: $color-text-link-100;

      &:hover {
        text-decoration: underline;
        filter: brightness(85%);
      }

      &:after {
        position: absolute;
        content: '→';
        padding-top: 2px;
        padding-left: 4px;
        width: 9px;
        text-decoration: none;
      }
    }
  }
}
</style>
